VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Auxiliar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function sDate(fecha As Variant) As String
    If IsDate(fecha) Then
        sDate = Format(fecha, "yyyymmdd")
    Else
        sDate = ""
    End If
End Function

Public Function dDate(yyyymmdd As Variant) As String
    If yyyymmdd <> "" Then
        dDate = Mid$(yyyymmdd, 7, 2) & "/" & Mid$(yyyymmdd, 5, 2) & "/" & Mid$(yyyymmdd, 1, 4)
    Else
        dDate = ""
    End If
End Function

Public Function vBuscarCampo(tabla As String, campo As String, condicion As String, Optional default As Variant) As Variant
    Dim strSQL As String
    Dim rs As ADODB.Recordset
    Dim cn As ADODB.Connection
    Dim pos As Integer
    
    Set cn = New ADODB.Connection
    cn.Open "File name=Contabilidad.udl"
    
    strSQL = "SELECT " & campo & " FROM " & tabla & " WHERE " & condicion
    
    Set rs = New ADODB.Recordset
    
    pos = InStr(1, UCase(campo), " AS ")
    If pos > 0 Then campo = Mid(campo, pos + 4)
    
    rs.Open strSQL, cn, adOpenStatic, adLockOptimistic
    vBuscarCampo = IIf(rs.EOF, default, IIf(IsNull(rs(campo)), default, rs(campo)))
    
    Set rs = Nothing
    Set cn = Nothing
End Function

Public Function vBuscarCampoTemporal(tabla As String, campo As String, condicion As String, Optional default As Variant) As Variant
    Dim strSQL As String
    Dim rs As ADODB.Recordset
    Dim cn As ADODB.Connection
    Dim pos As Integer
    
    Set cnt = New ADODB.Connection
    cnt.Open "File name=Temporal.udl"
    
    strSQL = "SELECT " & campo & " FROM " & tabla & " WHERE " & condicion
    
    Set rs = New ADODB.Recordset
    
    pos = InStr(1, UCase(campo), " AS ")
    If pos > 0 Then campo = Mid(campo, pos + 4)
    
    rs.Open strSQL, cnt, adOpenStatic, adLockOptimistic
    vBuscarCampoTemporal = IIf(rs.EOF, default, IIf(IsNull(rs(campo)), default, rs(campo)))
    
    Set rs = Nothing
    Set cnt = Nothing
End Function

Public Function DeleteExt(cn As ADODB.Connection, strTable As String, Optional strWhere As String)
    Dim strCmd As String
    Dim rs As ADODB.Recordset
    
    strCmd = "SELECT * FROM " & strTable
    
    If Len(strWhere) > 0 Then
        strCmd = strCmd & " WHERE " & strWhere
    End If
        
    Set rs = New ADODB.Recordset
    
    On Error GoTo DeleteError
    
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    While Not rs.EOF
        rs.Delete
        rs.MoveNext
    Wend
    
    rs.Close
    
    Set rs = Nothing
    
    Exit Function
DeleteError:
    Err.Raise Err.Number, , FormatError(cn, "Error en DeleteExt.")
End Function

Public Function GetListExt(cn As ADODB.Connection, strTable As String, strFields As String, Optional strWhere As String, _
Optional strGroup As String, Optional strHaving As String, Optional strOrder As String) As Object
    Dim strCmd As String
    Dim rs As ADODB.Recordset
    
    strCmd = "SELECT " & strFields & " FROM " & strTable
    
    If Len(strWhere) > 0 Then
        strCmd = strCmd & " WHERE " & strWhere
    End If
    
    If Len(strGroup) > 0 Then
        strCmd = strCmd & " GROUP BY " & strGroup
    End If
    
    If Len(strHaving) > 0 Then
        strCmd = strCmd & " HAVING BY " & strHaving
    End If
    
    If Len(strOrder) > 0 Then
        strCmd = strCmd & " ORDER BY " & strOrder
    End If
    
    Set rs = New ADODB.Recordset
    
    On Error GoTo GetListError
    
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    Set GetListExt = rs
    
    Exit Function
GetListError:
    Err.Raise Err.Number, , FormatError(cn, "Error en GetListExt.")
End Function

Private Function FormatError(cn As ADODB.Connection, strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    For Each eError In cn.Errors
        sAux = sAux & eError.Source & " (Referencia " & eError.Number & "): " & eError.Description & vbCrLf
    Next eError
    
    FormatError = sAux
End Function


