VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Delegaciones"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum ErroresDelegaciones
    iInsertError = (vbObjectError + 1)
    iUpdateError = (vbObjectError + 2)
    iDeleteError = (vbObjectError + 3)
    iListError = (vbObjectError + 4)
End Enum

Dim mAuxiliar As Auxiliar

Private Function sDate(fecha As Variant) As String
    Set mAuxiliar = New Auxiliar
    sDate = mAuxiliar.sDate(fecha)
    Set mAuxiliar = Nothing
End Function

Public Sub Insert(cn As ADODB.Connection, codigo_empresa As String, codigo_delegacion As String, nombre As String, _
direccion As String, cp As String, poblacion As String, provincia As String, pais As String, telefono As String, _
fax As String, correo As String, ultimo_usuario As String, transaccion_activa As Boolean)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    Dim rsAux As New ADODB.Recordset
    
    On Error GoTo InsertError
            
    If Not transaccion_activa Then cn.BeginTrans
    
    strCmd = "SELECT * FROM Delegaciones WHERE 1 = 0"
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    rs.AddNew
    rs("codigo_empresa") = codigo_empresa
    rs("codigo_delegacion") = codigo_delegacion
    rs("nombre") = nombre
    rs("direccion") = direccion
    rs("cp") = cp
    rs("poblacion") = poblacion
    rs("provincia") = provincia
    rs("pais") = pais
    rs("telefono") = telefono
    rs("fax") = fax
    rs("correo") = correo
    rs("ultima_modificacion") = sDate(Date)
    rs("ultimo_usuario") = ultimo_usuario
    
    rs.Update
    rs.Close
    
    strCmd = "SELECT codigo_usuario FROM Usuarios GROUP BY codigo_usuario"
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    If Not rs.EOF Then
        strCmd = "SELECT * FROM UsuariosDelegaciones WHERE 1 = 0"
        rsAux.Open strCmd, cn, adOpenStatic, adLockOptimistic
        
        rs.MoveFirst
        While Not rs.EOF
            rsAux.AddNew
            rsAux("codigo_usuario") = rs("codigo_usuario")
            rsAux("codigo_empresa") = codigo_empresa
            rsAux("codigo_delegacion") = codigo_delegacion
            rsAux("activo") = 0
            rsAux("ultima_modificacion") = sDate(Date)
            rsAux("ultimo_usuario") = ultimo_usuario
            rsAux.Update
            
            rs.MoveNext
        Wend
        
        rsAux.Close
    End If
    
    rs.Close
    
    If Not transaccion_activa Then cn.CommitTrans
    
    Set rs = Nothing
    Set rsAux = Nothing
        
    Exit Sub
InsertError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iInsertError, , FormatError(cn, "Error en Insert.")
End Sub

Public Sub Update(cn As ADODB.Connection, codigo_empresa As String, codigo_delegacion As String, nombre As String, _
direccion As String, cp As String, poblacion As String, provincia As String, pais As String, telefono As String, _
fax As String, correo As String, ultimo_usuario As String, transaccion_activa As Boolean)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    
    On Error GoTo UpdateError
    
    If Not transaccion_activa Then cn.BeginTrans
    
    strCmd = "SELECT * FROM Delegaciones WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" _
        & codigo_delegacion & "'"
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    rs("nombre") = nombre
    rs("direccion") = direccion
    rs("cp") = cp
    rs("poblacion") = poblacion
    rs("provincia") = provincia
    rs("pais") = pais
    rs("telefono") = telefono
    rs("fax") = fax
    rs("correo") = correo
    rs("ultima_modificacion") = sDate(Date)
    rs("ultimo_usuario") = ultimo_usuario
    
    rs.Update
    rs.Close
        
    If codigo_empresa = codigo_delegacion Then
        strCmd = "SELECT * FROM Empresas WHERE codigo_empresa = '" & codigo_empresa & "'"
        rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
        
        rs("nombre") = nombre
        rs("direccion") = direccion
        rs("cp") = cp
        rs("poblacion") = poblacion
        rs("provincia") = provincia
        rs("pais") = pais
        rs("telefono") = telefono
        rs("fax") = fax
        rs("correo") = correo
        rs("ultima_modificacion") = sDate(Date)
        rs("ultimo_usuario") = ultimo_usuario
        
        rs.Update
        rs.Close
    End If

    If Not transaccion_activa Then cn.CommitTrans
    
    Set rs = Nothing
    
    Exit Sub
UpdateError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iUpdateError, , FormatError(cn, "Error en Update.")
End Sub

Public Sub Delete(cn As ADODB.Connection, codigo_empresa As Variant, codigo_delegacion As Variant, transaccion_activa As Boolean)
    Dim strCmd As String
    
    On Error GoTo DeleteError
    
    If Not transaccion_activa Then cn.BeginTrans
    
    strCmd = "DELETE FROM RegistroIRPF WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd
    
    strCmd = "DELETE FROM RegistroIVA WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd

    strCmd = "DELETE FROM Cartera WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd
    
    strCmd = "DELETE FROM Apuntes WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd
    
    strCmd = "DELETE FROM RestriccionesUsuariosMenus WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd
    
    strCmd = "DELETE FROM UsuariosDelegaciones WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd
    
    strCmd = "DELETE FROM Delegaciones WHERE codigo_empresa = '" & codigo_empresa & "' AND codigo_delegacion = '" & codigo_delegacion & "'"
    cn.Execute strCmd
        
    If Not transaccion_activa Then cn.CommitTrans
    
    Exit Sub
DeleteError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iDeleteError, , FormatError(cn, "Error en Delete.")
End Sub

Public Function GetList(cn As ADODB.Connection, Optional strWhere As String, Optional strOrder As String) As Object
    Dim strCmd As String
    Dim rs As ADODB.Recordset
    
    strCmd = "SELECT * FROM Delegaciones"
    
    If Len(strWhere) > 0 Then
        strCmd = strCmd & " WHERE " & strWhere
    End If
    
    If Len(strOrder) > 0 Then
        strCmd = strCmd & " ORDER BY " & strOrder
    End If
        
    Set rs = New ADODB.Recordset
    
    On Error GoTo GetListError
    
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic
    
    Set GetList = rs
    
    Exit Function
GetListError:
    Err.Raise iListError, , FormatError(cn, "Error en GetList.")
End Function
    
Private Function FormatError(cn As ADODB.Connection, strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    For Each eError In cn.Errors
        sAux = sAux & eError.Source & " (Referencia " & eError.Number & "): " & eError.Description & vbCrLf
    Next eError
    
    FormatError = sAux
End Function
