VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Informes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
 
Public Enum ErroresInformes
    iListError = (vbObjectError + 4)
    iConnectError = (vbObjectError + 1001)
    iExecuteError = (vbObjectError + 1002)
End Enum

Enum PRINTMODES
    PRINTERMODE
    SCREENMODE
    QUESTIONMODE
End Enum

Private mvarStringConnection As String
Private mvarPrintMode As PRINTMODES
Private mvarErrorHandlerMode As Byte
Private mvarMaxParam As Integer
Private mvarMaxFormulas As Integer
Private mvarConnected As Boolean

Private mvarObj As CrystalReport

Public Sub Clear(Optional maxFormulas As Variant, Optional maxParam As Variant)
    Dim intI As Integer
    Dim intMaxF As Integer
    Dim intMaxP As Integer

    If IsMissing(maxFormulas) Then
        intMaxF = mvarMaxFormulas
    Else
        intMaxF = maxFormulas
    End If

    If IsMissing(maxParam) Then
        intMaxP = mvarMaxParam
    Else
        intMaxP = maxParam
    End If

    If intMaxP > mvarMaxParam Then
        mvarMaxParam = maxParam
    End If

    If intMaxF > mvarMaxFormulas Then
        mvarMaxFormulas = maxFormulas
    End If

    With mvarObj
        .ReportFileName = Empty
        .WindowTitle = Empty
        .GroupSelectionFormula = Empty
        .SelectionFormula = Empty
        .SQLQuery = Empty
    
        For intI = 0 To intMaxF - 1
            .Formulas(intI) = Empty
        Next
    
        For intI = 0 To intMaxP - 1
            .StoredProcParam(intI) = Empty
        Next
    End With
End Sub

Private Sub rptConnect()
    On Error GoTo ConnectError

    'mvarObj.Connect = mvarStringConnection
    mvarObj.LogonInfo(0) = "DSN=" & App.Path & "\Dades\Temporales.mde;UID=Admin"
    mvarConnected = True
    Exit Sub

ConnectError:
    Dim strError As String
    
    strError = Err.Description
    mvarConnected = False
    Err.Raise iConnectError, , FormatError("Error en rptConnect. " & strError & ".")
End Sub

Public Sub Execute()
    On Error GoTo ExecuteError

    If Not mvarConnected Then
        Call rptConnect
    End If

    Select Case mvarPrintMode
        Case PRINTERMODE
            mvarObj.Destination = crptToPrinter
        Case SCREENMODE
            mvarObj.Destination = crptToWindow
        Case QUESTIONMODE
            If MsgBox(" Desea imprimir directamente el informe?", vbYesNo) = vbYes Then
                mvarObj.Destination = crptToPrinter
            Else
                mvarObj.Destination = crptToWindow
            End If
    End Select

    mvarObj.Action = 1

    Call Clear
    Exit Sub

ExecuteError:
    Dim strError As String
    
    strError = Err.Description
    Call Clear
    Err.Raise iExecuteError, , FormatError("Error en Execute. " & strError & ".")
End Sub

Public Sub rptFormulas(ParamArray paramFormulas())
    Dim intI As Integer

    If UBound(paramFormulas) + 1 > mvarMaxFormulas Then
        mvarMaxFormulas = UBound(paramFormulas) + 1
    End If

    With mvarObj
        For intI = LBound(paramFormulas) To UBound(paramFormulas)
            .Formulas(intI) = paramFormulas(intI)
        Next intI
    End With
End Sub

Public Sub UspParam(ParamArray paramProc())
    Dim intI As Integer

    If UBound(paramProc) + 1 > mvarMaxParam Then
        mvarMaxParam = UBound(paramProc) + 1
    End If

    With mvarObj
        For intI = LBound(paramProc) To UBound(paramProc)
            .StoredProcParam(intI) = paramProc(intI)
        Next intI
    End With
End Sub

Public Sub Configure(strName As String, strDescription As String, printMode As PRINTMODES)
    Call Clear

    mvarPrintMode = printMode

    With mvarObj
        .DataFiles(0) = App.Path & "\Dades\Temporales.mde"
        .ReportFileName = App.Path & "\Reports\" & strName
        .WindowTitle = strDescription
    End With
End Sub

Public Sub Init(strConnect As String, errorMode As Byte, crtObj As CrystalReport)
    mvarStringConnection = strConnect
    mvarErrorHandlerMode = errorMode
    Set mvarObj = crtObj
    mvarConnected = False
End Sub

Public Property Set obj(ByVal vData As CrystalReport)
    Set mvarObj = vData
End Property

Public Property Get obj() As CrystalReport
    Set obj = mvarObj
End Property

Public Property Let ErrorHandlerMode(ByVal vData As Byte)
    mvarErrorHandlerMode = vData
End Property

Public Property Get ErrorHandlerMode() As Byte
    ErrorHandlerMode = mvarErrorHandlerMode
End Property

Public Property Let printMode(ByVal vData As PRINTMODES)
    mvarPrintMode = vData
End Property

Public Property Get printMode() As PRINTMODES
    printMode = mvarPrintMode
End Property

Public Property Let STRCON(ByVal vData As String)
    mvarStringConnection = vData
End Property

Public Property Get STRCON() As String
    STRCON = mvarStringConnection
End Property

Private Sub Class_Terminate()
    Clear
    Set mvarObj = Nothing
End Sub

Private Function FormatError(strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    FormatError = sAux
End Function

