VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Regularizacion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum ErroresRegularizacion
    iInsertError = (vbObjectError + 1)
    iDeleteError = (vbObjectError + 3)
    iListError = (vbObjectError + 4)
End Enum

Dim mAuxiliar As Auxiliar
Dim mApuntes As Apuntes
Dim mEjercicios As Ejercicios

Public Sub Insert(cn As ADODB.Connection, codigo_empresa As String, ejercicio As Integer, cuenta As String, _
codigo_documento As String, ultimo_usuario As String, transaccion_activa As Boolean)
    Dim strCmd As String
    Dim debe As Double
    Dim haber As Double
    Dim apunte As Integer
    Dim rs As ADODB.Recordset
    Dim rsAux As ADODB.Recordset
        
    On Error GoTo InsertError
    
    apunte = 1
    debe = 0: haber = 0
        
    Set mEjercicios = New Ejercicios
    Set rsAux = mEjercicios.GetList(cn, "codigo_empresa = '" & codigo_empresa & "' and ejercicio = " & ejercicio)
    
    strCmd = "SELECT cuenta, SUM(debe-haber) AS saldo FROM Apuntes WHERE codigo_empresa = '" & codigo_empresa _
        & "' AND fecha_apunte BETWEEN '" & rsAux("fecha_inicial") & "' AND '" & rsAux("fecha_final") & "' " _
        & "AND cuenta >= '6' AND cuenta < '8' GROUP BY cuenta HAVING SUM(debe-haber) <> 0 ORDER BY cuenta"
       
    Set rs = New ADODB.Recordset
        
    rs.Open strCmd, cn, adOpenStatic, adLockOptimistic

    If Not rs.EOF Then
        Set mApuntes = New Apuntes
        Set mAuxiliar = New Auxiliar
        
        If Not transaccion_activa Then cn.BeginTrans
        
        While Not rs.EOF
            If rs("saldo") > 0 Then
                mApuntes.Insert cn, sEmpresa, sEmpresa, codigo_documento, String(9, "9") & 8, Format(apunte, "00000"), "99999", mAuxiliar.dDate(rsAux("fecha_final")), "", "", rs("cuenta"), "ASIENTO DE REGULARIZACIN", 0, str(rs("saldo")), "A", "", ultimo_usuario
                haber = haber + rs("saldo")
            Else
                mApuntes.Insert cn, sEmpresa, sEmpresa, codigo_documento, String(9, "9") & 8, Format(apunte, "00000"), "99999", mAuxiliar.dDate(rsAux("fecha_final")), "", "", rs("cuenta"), "ASIENTO DE REGULARIZACIN", str(-rs("saldo")), 0, "A", "", ultimo_usuario
                debe = debe + Abs(rs("saldo"))
            End If
            
            apunte = apunte + 1
            rs.MoveNext
        Wend
        
        If debe > haber Then
            mApuntes.Insert cn, sEmpresa, sEmpresa, codigo_documento, String(9, "9") & 8, Format(apunte, "00000"), "99999", mAuxiliar.dDate(rsAux("fecha_final")), "", "", cuenta, "ASIENTO DE REGULARIZACIN", 0, str(debe - haber), "A", "", ultimo_usuario
        ElseIf haber > debe Then
            mApuntes.Insert cn, sEmpresa, sEmpresa, codigo_documento, String(9, "9") & 8, Format(apunte, "00000"), "99999", mAuxiliar.dDate(rsAux("fecha_final")), "", "", cuenta, "ASIENTO DE REGULARIZACIN", str(haber - debe), 0, "A", "", ultimo_usuario
        End If
    
        mEjercicios.Update cn, sEmpresa, ejercicio, mAuxiliar.dDate(rsAux("fecha_inicial")), mAuxiliar.dDate(rsAux("fecha_final")), mAuxiliar.dDate(rsAux("inicio_bloqueo")), mAuxiliar.dDate(rsAux("final_bloqueo")), "S", rsAux("cerrado"), ultimo_usuario
        
        If Not transaccion_activa Then cn.CommitTrans
        
        Set mAuxiliar = Nothing
        Set mApuntes = Nothing
    End If
    
    Set mEjercicios = Nothing

    rs.Close
    Set rs = Nothing
    
    Exit Sub
InsertError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iInsertError, , FormatError(cn, "Error en Insert.")
End Sub

Public Sub Delete(cn As ADODB.Connection, codigo_empresa As String, ejercicio As Integer, codigo_documento As String, _
ultimo_usuario As String, transaccion_activa As Boolean)
    Dim strCmd As String
    Dim rs As New ADODB.Recordset
    
    On Error GoTo DeleteError
    
    If Not transaccion_activa Then cn.BeginTrans
    
    strCmd = "DELETE FROM Apuntes WHERE codigo_empresa = '" & codigo_empresa _
        & "' AND codigo_delegacion = '" & codigo_empresa & "' AND codigo_documento = '" _
        & codigo_documento & "' AND numero_documento = '" & String(9, "9") & 8 & "'"
    cn.Execute strCmd
    
    Set mAuxiliar = New Auxiliar
    
    Set mEjercicios = New Ejercicios
    Set rs = mEjercicios.GetList(cn, "codigo_empresa = '" & codigo_empresa & "' and ejercicio = " & ejercicio)
    mEjercicios.Update cn, sEmpresa, iEjercicio, mAuxiliar.dDate(rs("fecha_inicial")), mAuxiliar.dDate(rs("fecha_final")), mAuxiliar.dDate(rs("inicio_bloqueo")), mAuxiliar.dDate(rs("final_bloqueo")), "N", rs("cerrado"), ultimo_usuario
    Set mEjercicios = Nothing
    
    Set mAuxiliar = Nothing
    
    If Not transaccion_activa Then cn.CommitTrans
    
    Set rs = Nothing
    
    Exit Sub
DeleteError:
    If Not transaccion_activa Then cn.RollbackTrans
    Err.Raise iDeleteError, , FormatError(cn, "Error en Delete.")
End Sub

Public Function GetList(cn As ADODB.Connection, Optional strWhere As String, Optional strOrder As String) As Object
    Dim rs As ADODB.Recordset
    
    Set mApuntes = New Apuntes
    Set rs = mApuntes.GetList(cn, strWhere, strOrder)
    Set mApuntes = Nothing
    
    Set GetList = rs
    
    Exit Function
GetListError:
    Err.Raise iListError, , FormatError(cn, "Error en GetList.")
End Function
    
Private Function FormatError(cn As ADODB.Connection, strError As String) As String
    Dim eError As ADODB.Error
    Dim sAux As String
    
    If Len(strError) > 0 Then
        sAux = strError & vbCrLf
    End If
    
    For Each eError In cn.Errors
        sAux = sAux & eError.Source & " (Referencia " & eError.Number & "): " & eError.Description & vbCrLf
    Next eError
    
    FormatError = sAux
End Function


