Attribute VB_Name = "API"
Option Explicit

Public Const ICC_LISTVIEW_CLASSES  As Long = &H1
Public Const LVM_FIRST = &H1000
Public Const LVM_GETHEADER = (LVM_FIRST + 31)

Public Type NMHDR
    hWndFrom As Long
    idfrom   As Long
    code     As Long
End Type

Public Type HD_ITEM
    mask        As Long
    cxy         As Long
    pszText     As String
    hbm         As Long
    cchTextMax  As Long
    fmt         As Long
    lParam      As Long
    iImage      As Long
    iOrder      As Long
End Type

Public Type NMHEADER
    hdr         As NMHDR
    iItem       As Long
    iButton     As Long
    hbm         As Long
    HDI         As HD_ITEM
End Type

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type HD_HITTESTINFO
    pt  As POINTAPI
    flags  As Long
    iItem As Long
End Type

Public Type tagINITCOMMONCONTROLSEX
    dwSize As Long
    dwICC As Long
End Type

'HitTest positions
Public Const HHT_NOWHERE = &H1
Public Const HHT_ONHEADER = &H2
Public Const HHT_ONDIVIDER = &H4
Public Const HHT_ONDIVOPEN = &H8
Public Const HHT_ABOVE = &H100
Public Const HHT_BELOW = &H200
Public Const HHT_TORIGHT = &H400
Public Const HHT_TOLEFT = &H800

'header class id's
Public Const HEADER32_CLASS   As String = "SysHeader32"
Public Const HEADER_CLASS     As String = "SysHeader"

'header info
Public Const HDI_WIDTH        As Long = &H1
Public Const HDI_HEIGHT       As Long = HDI_WIDTH
Public Const HDI_TEXT         As Long = &H2
Public Const HDI_FORMAT       As Long = &H4
Public Const HDI_LPARAM       As Long = &H8
Public Const HDI_BITMAP       As Long = &H10
Public Const HDI_IMAGE        As Long = &H20
Public Const HDI_DI_SETITEM   As Long = &H40
Public Const HDI_ORDER        As Long = &H80

'header formats
Public Const HDF_LEFT         As Long = 0
Public Const HDF_RIGHT        As Long = 1
Public Const HDF_CENTER       As Long = 2
Public Const HDF_JUSTIFYMASK  As Long = &H3
Public Const HDF_RTLREADING   As Long = 4
Public Const HDF_IMAGE        As Long = &H800
Public Const HDF_OWNERDRAW    As Long = &H8000&
Public Const HDF_STRING       As Long = &H4000
Public Const HDF_BITMAP       As Long = &H2000
Public Const HDF_BITMAP_ON_RIGHT  As Long = &H1000

'header styles
Public Const HDS_HORZ         As Long = &H0
Public Const HDS_BUTTONS      As Long = &H2
Public Const HDS_HOTTRACK     As Long = &H4
Public Const HDS_HIDDEN       As Long = &H8
Public Const HDS_DRAGDROP     As Long = &H40
Public Const HDS_FULLDRAG     As Long = &H80

'header messages
Public Const HDM_FIRST           As Long = &H1200
Public Const HDM_GETITEMCOUNT    As Long = (HDM_FIRST + 0)
Public Const HDM_INSERTITEM      As Long = (HDM_FIRST + 1)
Public Const HDM_DELETEITEM      As Long = (HDM_FIRST + 2)
Public Const HDM_GETITEM         As Long = (HDM_FIRST + 3)
Public Const HDM_SETITEM         As Long = (HDM_FIRST + 4)
Public Const HDM_LAYOUT          As Long = (HDM_FIRST + 5)
Public Const HDM_HITTEST         As Long = (HDM_FIRST + 6)
Public Const HDM_GETITEMRECT     As Long = (HDM_FIRST + 7)
Public Const HDM_SETIMAGELIST    As Long = (HDM_FIRST + 8)
Public Const HDM_GETIMAGELIST    As Long = (HDM_FIRST + 9)
Public Const HDM_ORDERTOINDEX    As Long = (HDM_FIRST + 15)

'notify messages
Public Const HDN_FIRST As Long = -300&
Public Const HDN_ITEMCLICK = (HDN_FIRST - 2)
Public Const HDN_DIVIDERDBLCLICK = (HDN_FIRST - 5)
Public Const HDN_BEGINTRACK = (HDN_FIRST - 6)
Public Const HDN_ENDTRACK = (HDN_FIRST - 7)
Public Const HDN_TRACK = (HDN_FIRST - 8)
Public Const HDN_GETDISPINFO = (HDN_FIRST - 9)
Public Const HDN_BEGINDRAG = (HDN_FIRST - 10)
Public Const HDN_ENDDRAG = (HDN_FIRST - 11)
Public Const HDN_ITEMCHANGING As Long = (HDN_FIRST - 0)
Public Const HDN_ITEMDBLCLICK As Long = (HDN_FIRST - 3)

Public Const NM_FIRST As Long = &H0
Public Const NM_RCLICK As Long = (NM_FIRST - 5)

'windows constants
Public Const GWL_STYLE        As Long = (-16)
Public Const WM_USER  As Long = &H400
Public Const WM_SIZE  As Long = &H5
Public Const WM_NOTIFY        As Long = &H4E&

Public Declare Function GetComputerName Lib "kernel32" Alias _
    "GetComputerNameA" (ByVal lpbuffer As String, nSize As Long) As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias _
    "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Declare Function WritePrivateProfileString Lib "kernel32" Alias _
    "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Declare Function CallWindowProc Lib "user32" Alias _
    "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias _
    "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Declare Function GetProp Lib "user32" Alias _
    "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long

Public Declare Function SetProp Lib "user32" Alias _
    "SetPropA" (ByVal hwnd As Long, ByVal lpString As String, ByVal hData As Long) As Long

Public Declare Function GetWindowLong Lib "user32" Alias _
    "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias _
    "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Declare Function SendMessage Lib "user32" Alias _
    "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Any, lParam As Any) As Long
   
Public Declare Function GetCursorPos Lib "user32" _
    (lpPoint As POINTAPI) As Long

Public Declare Function ScreenToClient Lib "user32" _
    (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
 
Public Declare Function InitCommonControlsEx Lib "comctl32" _
   (lpInitCtrls As tagINITCOMMONCONTROLSEX) As Boolean

Public Declare Sub InitCommonControls Lib "comctl32" ()

